Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.io.comparator
Class ExtensionFileComparator

    java.lang.Object
      org.apache.commons.io.comparator.ExtensionFileComparator

All Implemented Interfaces:
  Serializable, Comparator

    public class ExtensionFileComparator

extends Object
implements Comparator, Serializable

Compare the file name extensions for order (see `FilenameUtils.getExtension(String)`).

This comparator can be used to sort lists or arrays of files by their file extension either in a case-sensitive, case-insensitive or system dependant case sensitive way. A number of singleton instances are provided for the various case sensitivity options (using `IOCase`) and the reverse of those options.

Example of a case-sensitive file extension sort using the `EXTENSION_COMPARATOR` singleton instance:

           List<File> list = ...
           Collections.sort(list, ExtensionFileComparator.EXTENSION_COMPARATOR);

Example of a reverse case-insensitive file extension sort using the `EXTENSION_INSENSITIVE_REVERSE` singleton instance:

           File[] array = ...
           Arrays.sort(array, ExtensionFileComparator.EXTENSION_INSENSITIVE_REVERSE);

Since:
  Commons IO 1.4
Version:
  $Revision: 609243 $ $Date: 2008-01-06 00:30:42 +0000 (Sun, 06 Jan 2008) $
See Also:
  Serialized Form

Field Summary
`static Comparator` | `EXTENSION_COMPARATOR` Case-sensitive extension comparator instance (see `IOCase.SENSITIVE`)
`static Comparator` | `EXTENSION_INSENSITIVE_COMPARATOR` Case-insensitive extension comparator instance (see `IOCase.INSENSITIVE`)
`static Comparator` | `EXTENSION_INSENSITIVE_REVERSE` Reverse case-insensitive extension comparator instance (see `IOCase.INSENSITIVE`)
`static Comparator` | `EXTENSION_REVERSE` Reverse case-sensitive extension comparator instance (see `IOCase.SENSITIVE`)
`static Comparator` | `EXTENSION_SYSTEM_COMPARATOR` System sensitive extension comparator instance (see `IOCase.SYSTEM`)
`static Comparator` | `EXTENSION_SYSTEM_REVERSE` Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)

Constructor Summary
`ExtensionFileComparator()` Construct a case sensitive file extension comparator instance.
`ExtensionFileComparator(IOCase caseSensitivity)` Construct a file extension comparator instance with the specified case-sensitivity.

Method Summary
`int` | `compare(Object obj1, Object obj2)` Compare the extensions of two files the specified case sensitivity.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.util.Comparator
`equals`

Field Detail

### EXTENSION_COMPARATOR

    public static final Comparator EXTENSION_COMPARATOR

  Case-sensitive extension comparator instance (see `IOCase.SENSITIVE`)

### EXTENSION_REVERSE

    public static final Comparator EXTENSION_REVERSE

  Reverse case-sensitive extension comparator instance (see `IOCase.SENSITIVE`)

### EXTENSION_INSENSITIVE_COMPARATOR

    public static final Comparator EXTENSION_INSENSITIVE_COMPARATOR

  Case-insensitive extension comparator instance (see `IOCase.INSENSITIVE`)

### EXTENSION_INSENSITIVE_REVERSE

    public static final Comparator EXTENSION_INSENSITIVE_REVERSE

  Reverse case-insensitive extension comparator instance (see `IOCase.INSENSITIVE`)

### EXTENSION_SYSTEM_COMPARATOR

    public static final Comparator EXTENSION_SYSTEM_COMPARATOR

  System sensitive extension comparator instance (see `IOCase.SYSTEM`)

### EXTENSION_SYSTEM_REVERSE

    public static final Comparator EXTENSION_SYSTEM_REVERSE

  Reverse system sensitive path comparator instance (see `IOCase.SYSTEM`)

Constructor Detail

### ExtensionFileComparator

    public ExtensionFileComparator()

  Construct a case sensitive file extension comparator instance.

### ExtensionFileComparator

    public ExtensionFileComparator(IOCase caseSensitivity)

  Construct a file extension comparator instance with the specified case-sensitivity.

  Parameters:
    `caseSensitivity` - how to handle case sensitivity, null means case-sensitive

Method Detail

### compare

    public int compare(Object obj1,
                       Object obj2)

  Compare the extensions of two files the specified case sensitivity.

  Specified by:
    `compare` in interface `Comparator`
  Parameters:
    `obj1` - The first file to compare
    `obj2` - The second file to compare
  Returns:
    a negative value if the first file's extension is less than the second, zero if the extensions are the same and a positive value if the first files extension is greater than the second file.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Apache Software Foundation. All Rights Reserved.